// book.java
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;

/**
 *  A class that represents a single book.
 *  @version 1.1
 *  @author Michael C. Daconta
 */
public class book
{
    /** Title of the book. */
    protected String title;

    /** Author of the book. */
    protected String author;

    /** Publisher of the book. */
    protected String publisher;

    /** A reference to the next book object in the list. */
    book next;

    /**
     * Constructor to create an "empty" book.
     * Class data members initialized by JVM.
     */
    public book() { }

    /**
     * A constructor to create a new book given title, author, and
     * publisher.
     */
    public book(String aTitle, String anAuthor, String aPublisher)
    {
        title = aTitle;
        author = anAuthor;
        publisher = aPublisher;
    }

    /**
     * This method prompts the user for the information necessary
     * for a valid book object.
     */
    public void getBook()
    {
        try
        {
            InputStreamReader isr = new InputStreamReader(System.in);
            BufferedReader br = new BufferedReader(isr);
            System.out.print("Enter title    : ");
            System.out.flush();
            title = br.readLine();
            if (title.equals("done"))
                return;
            System.out.print("Enter author   : ");
            System.out.flush();
            author = br.readLine();
            System.out.print("Enter publisher: ");
            System.out.flush();
            publisher = br.readLine();
        } catch (IOException ioe)
          {
            System.out.println(ioe.toString());
            System.out.println("Unable to get the book data.");
            return;
          }
    }

    /**
     * A method to display the contents of a book object.
     */
    void showBook()
    {
        System.out.println("Title    : " + title);
        System.out.println("Author   : " + author);
        System.out.println("Publisher: " + publisher);
    }

    /** Accessor method to get the title. */
    String getTitle() { return title; }

    /** Accessor method to get the author. */
    String getAuthor() { return author; }

    /** Accessor method to get the publisher. */
    String getPublisher() { return publisher; }

    /** Mutator method to set the title. */
    void setTitle(String aTitle) { title = aTitle; }

    /** Mutator method to set the author. */
    void setAuthor(String anAuthor) { author = anAuthor; }

    /** Mutator method to set the publisher. */
    void setPublisher(String aPublisher) { publisher = aPublisher; }
}
