
package jwiley.chp10;

import java.awt.datatransfer.*;
import java.io.IOException;
import java.io.ByteArrayInputStream;

public class AsciiTextFlavor
    implements Transferable, ClipboardOwner
{
    String      sData;
    DataFlavor  dataFlavors[];

    public AsciiTextFlavor(String sData)
    {
        this.sData = sData;

        // create my array of data flavors
        try
        {
            dataFlavors = new DataFlavor[1];
            dataFlavors[0] =
              new DataFlavor("text/plain; class=java.io.InputStream; charset=ascii");
        }
        catch (Exception e) { }
    }

    public synchronized DataFlavor[] getTransferDataFlavors()
    {
        return (dataFlavors);
    }

    public boolean isDataFlavorSupported(DataFlavor dataFlavor)
    {
        if (dataFlavor.equals(dataFlavors[0]))
            return true;
        else
            return false;
    }

    public synchronized Object getTransferData(DataFlavor dataFlavor)
			            throws UnsupportedFlavorException, IOException
    {
	    if (dataFlavor.equals(dataFlavors[0]))
	    {
	        if (sData != null)
	            return (new ByteArrayInputStream(sData.getBytes()));
	        else
	            throw new IOException("No data available, data is null");
	    }
    	else
    	{
    	    throw new UnsupportedFlavorException(dataFlavor);
	    }
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents) { }
}