
package jwiley.chp10;

import java.awt.*;
import java.awt.event.*;

public class ColorPopupMenu extends PopupMenu implements ItemListener
{
    CheckboxMenuItem mnuColorBlue = new CheckboxMenuItem("Blue");
    CheckboxMenuItem mnuColorGreen = new CheckboxMenuItem("Green");
    CheckboxMenuItem mnuColorRed = new CheckboxMenuItem("Red");
    CheckboxMenuItem mnuColorBlack = new CheckboxMenuItem("Black");

    DrawingObject   drawObject;
    DrawCanvas      drawCanvas;

    public ColorPopupMenu (DrawingObject drawObject,
                           DrawCanvas drawCanvas,
                           Color colorSelected)
    {
        this.drawObject = drawObject;
        this.drawCanvas = drawCanvas;

        add(mnuColorBlue);
        add(mnuColorGreen);
        add(mnuColorRed);
        add(mnuColorBlack);

        mnuColorBlue.addItemListener(this);
        mnuColorGreen.addItemListener(this);
        mnuColorRed.addItemListener(this);
        mnuColorBlack.addItemListener(this);

        if (colorSelected == Color.blue)
            mnuColorBlue.setState(true);
        else if (colorSelected == Color.green)
            mnuColorGreen.setState(true);
        else if (colorSelected == Color.red)
            mnuColorRed.setState(true);
        else if (colorSelected == Color.black)
            mnuColorBlack.setState(true);
    }

    public void itemStateChanged (ItemEvent evt)
    {
        Object target = evt.getSource();
        if (evt.getStateChange() == ItemEvent.SELECTED)
        {
            if (target == mnuColorBlue)
                drawObject.setColor(Color.blue);
            else if (target == mnuColorGreen)
                drawObject.setColor(Color.green);
            else if (target == mnuColorRed)
                drawObject.setColor(Color.red);
            else if (target == mnuColorBlack)
                drawObject.setColor(Color.black);

            // force repaint but keep it selected
            drawObject.deselect(drawCanvas);
            drawObject.select(drawCanvas);
        }
    }
}