import java.awt.*;

class keyboardCanvas extends Canvas {
        private Rectangle board;
        private Rectangle keys[][];
        private Rectangle spaceBar;
        private int keySize;
        static String letters0[] = { "1", "2", "3", "4", "5", "6", "7", "8",
                                     "9", "0", "]", "}" };
        static String letters1[] = { "\"", "<", ">", "P", "Y", "F", "G", "C",
                                     "R", "L", "?", "+" };
        static String letters2[] = { "A", "O", "E", "U", "I", "D", "H", "T",
                                     "N", "S", "_" };
        static String letters3[] = { ":", "Q", "J", "K", "X", "B", "M", "W",
                                     "V", "Z" };

        public boolean pressed[][];
        public Point asciiPos[];
        public boolean update;
        public int updateRow, updateCol;

        static String pos2String(int row, int col)
        {
                String outstr=null;
                switch (row) {
                        case 0:
                                outstr = letters0[col];
                                break;
                        case 1:
                                outstr = letters1[col];
                                break;
                        case 2:
                                outstr = letters2[col];
                                break;
                        case 3:
                                outstr = letters3[col];
                                break;
                }
                return outstr;
        }

        keyboardCanvas(Container parent)
        {
                Dimension psize = parent.size();

                // initialize variables
                update = false;

                // ascii position to dvorak key
                // start at ascii 33.
                asciiPos = new Point[96];
                asciiPos[0] = new Point(0,0); asciiPos[1] = new Point(1,0);
                asciiPos[2] = new Point(0,2); asciiPos[3] = new Point(0,3);
                asciiPos[4] = new Point(0,4); asciiPos[5] = new Point(0,6);
                asciiPos[6] = new Point(1,0); asciiPos[7] = new Point(0,8);
                asciiPos[8] = new Point(0,9); asciiPos[9] = new Point(0,7);
                asciiPos[10] = new Point(1,11); asciiPos[11] = new Point(1,1);
                asciiPos[12] = new Point(2,10); asciiPos[13] = new Point(1,2);
                asciiPos[14] = new Point(1,10); asciiPos[15] = new Point(0,9);
                asciiPos[16] = new Point(0,0); asciiPos[17] = new Point(0,1);
                asciiPos[18] = new Point(0,2); asciiPos[19] = new Point(0,3);
                asciiPos[20] = new Point(0,4); asciiPos[21] = new Point(0,5);
                asciiPos[22] = new Point(0,6); asciiPos[23] = new Point(0,7);
                asciiPos[24] = new Point(0,8); asciiPos[25] = new Point(3,0);
                asciiPos[26] = new Point(3,0); asciiPos[27] = new Point(1,1);
                asciiPos[28] = new Point(1,0); asciiPos[29] = new Point(1,2);
                asciiPos[30] = new Point(1,10); asciiPos[31] = new Point(0,1);
                asciiPos[32] = new Point(2,0); asciiPos[33] = new Point(3,5);
                asciiPos[34] = new Point(1,7); asciiPos[35] = new Point(2,5);
                asciiPos[36] = new Point(2,2); asciiPos[37] = new Point(1,5);
                asciiPos[38] = new Point(1,6); asciiPos[39] = new Point(2,6);
                asciiPos[40] = new Point(2,4); asciiPos[41] = new Point(3,2);
                asciiPos[42] = new Point(3,3); asciiPos[43] = new Point(1,9);
                asciiPos[44] = new Point(3,6); asciiPos[45] = new Point(2,8);
                asciiPos[46] = new Point(2,1); asciiPos[47] = new Point(1,3);
                asciiPos[48] = new Point(3,1); asciiPos[49] = new Point(1,8);
                asciiPos[50] = new Point(2,9); asciiPos[51] = new Point(2,7);
                asciiPos[52] = new Point(2,3); asciiPos[53] = new Point(3,8);
                asciiPos[54] = new Point(3,7); asciiPos[55] = new Point(3,4);
                asciiPos[56] = new Point(1,4); asciiPos[57] = new Point(3,9);
                asciiPos[58] = new Point(0,10); asciiPos[59] = new Point(-1,-1);
                asciiPos[60] = new Point(0,10); asciiPos[61] = new Point(-1,-1);
                asciiPos[62] = new Point(2,10); asciiPos[63] = new Point(-1,-1);
                asciiPos[64] = new Point(2,0); asciiPos[65] = new Point(3,5);
                asciiPos[66] = new Point(1,7); asciiPos[67] = new Point(2,5);
                asciiPos[68] = new Point(2,2); asciiPos[69] = new Point(1,5);
                asciiPos[70] = new Point(1,6); asciiPos[71] = new Point(2,6);
                asciiPos[72] = new Point(2,4); asciiPos[73] = new Point(3,2);
                asciiPos[74] = new Point(3,3); asciiPos[75] = new Point(1,9);
                asciiPos[76] = new Point(3,6); asciiPos[77] = new Point(2,8);
                asciiPos[78] = new Point(2,1); asciiPos[79] = new Point(1,3);
                asciiPos[80] = new Point(3,1); asciiPos[81] = new Point(1,8);
                asciiPos[82] = new Point(2,9); asciiPos[83] = new Point(2,7);
                asciiPos[84] = new Point(2,3); asciiPos[85] = new Point(3,8);
                asciiPos[86] = new Point(3,7); asciiPos[87] = new Point(3,4);
                asciiPos[88] = new Point(1,4); asciiPos[89] = new Point(3,9);
                asciiPos[90] = new Point(0,11); asciiPos[91] = new Point(0,11);
                asciiPos[92] = new Point(-1,-1); asciiPos[93] = new Point(-1,-1);

                setBackground(Color.gray);
                setForeground(Color.black);
                int boardSize = psize.width/8 * 4;
                board = new Rectangle(psize.width/8 * 2,
                                      2,boardSize
                                      ,80);
                spaceBar = new Rectangle(psize.width/16 * 6,
                                         84, psize.width/16 * 4,
                                         10);

                keys = new Rectangle[4][];
                keys[0] = new Rectangle[12];
                keys[1] = new Rectangle[12];
                keys[2] = new Rectangle[11];
                keys[3] = new Rectangle[10];

                // pressed array
                pressed = new boolean[4][12];

                for (int i=0; i < 4; i++)
                        for (int j=0; j < pressed[i].length; j++)
                                pressed[i][j] = false;

                keySize = boardSize/14;
                int RowStart[] = new int[4];
                RowStart[0] = psize.width/8 * 2 + keySize;
                RowStart[1] = RowStart[0] + keySize/2;
                RowStart[2] = RowStart[1] + keySize/2;
                RowStart[3] = RowStart[2] + keySize/2;

                for (int i = 0; i < 4; i++)
                        for (int j=0; j < keys[i].length; j++)
                                keys[i][j] = new Rectangle(RowStart[i] + (j * keySize),
                                                           board.y + (20 * i),
                                                           keySize, 20);

        }

        public void paint(Graphics g)
        {
            if (!update)
            {
                g.setColor(Color.black);
                g.drawRect(board.x-1,board.y-1,board.width+1,board.height+1);
                g.setColor(Color.white);
                g.fillRect(board.x,board.y,board.width, board.height);

                // space bar
                g.setColor(Color.black);
                g.drawRect(spaceBar.x-1, spaceBar.y-1, spaceBar.width+1,
                           spaceBar.height+1);
                g.setColor(Color.lightGray);
                g.fillRect(spaceBar.x, spaceBar.y, spaceBar.width,
                           spaceBar.height);
                g.setColor(Color.white);
                g.fillRoundRect(spaceBar.x+1, spaceBar.y+1,
                                spaceBar.width - 2,
                                spaceBar.height - 4, 5, 5);

                // key borders
                g.setColor(Color.black);
                g.drawLine(board.x, board.y+20, board.x + board.width,
                           board.y+20);
                // shorten for Return key
                g.drawLine(board.x, board.y+40,
                           board.x + (keySize * 13 + keySize/2),
                           board.y+40);
                g.drawLine(board.x, board.y+60, board.x + board.width,
                           board.y+60);

                // draw keys
                for (int i = 0; i < 4; i++)
                        for (int j=0; j < keys[i].length; j++)
                        {
                                g.setColor(Color.black);
                                g.drawRect(keys[i][j].x,
                                           keys[i][j].y,
                                           keys[i][j].width,
                                           keys[i][j].height);
                                g.setColor(Color.lightGray);
                                g.fillRect(keys[i][j].x+1,
                                           keys[i][j].y+1,
                                           keys[i][j].width-1,
                                           keys[i][j].height-1);

                                /* *** if key pressed change
                                       to yellow */
                                if (!pressed[i][j])
                                   g.setColor(Color.white);
                                else
                                   g.setColor(Color.yellow);

                                g.fillRoundRect(keys[i][j].x+2,
                                                keys[i][j].y+2,
                                                keys[i][j].width - 3,
                                                keys[i][j].height - 3, 2, 2);
                                // draw Letter
                                g.setColor(Color.black);
                                g.drawString(pos2String(i,j),
                                             keys[i][j].x + keySize/4,
                                             keys[i][j].y + (keys[i][j].height - 4));
                        }
            }
        }

        public void update(Graphics g)
        {
                                g.setColor(Color.black);
                                g.drawRect(keys[updateRow][updateCol].x,
                                           keys[updateRow][updateCol].y,
                                           keys[updateRow][updateCol].width,
                                           keys[updateRow][updateCol].height);
                                g.setColor(Color.lightGray);
                                g.fillRect(keys[updateRow][updateCol].x+1,
                                           keys[updateRow][updateCol].y+1,
                                           keys[updateRow][updateCol].width-1,
                                           keys[updateRow][updateCol].height-1);

                                /* *** if key pressed change
                                       to yellow */
                                if (!pressed[updateRow][updateCol])
                                   g.setColor(Color.white);
                                else
                                   g.setColor(Color.yellow);

                                g.fillRoundRect(keys[updateRow][updateCol].x+2,
                                                keys[updateRow][updateCol].y+2,
                                                keys[updateRow][updateCol].width - 3,
                                                keys[updateRow][updateCol].height - 3, 2, 2);
                                // draw Letter
                                g.setColor(Color.black);
                                g.drawString(pos2String(updateRow,updateCol),
                                             keys[updateRow][updateCol].x + keySize/4,
                                             keys[updateRow][updateCol].y +
                                                (keys[updateRow][updateCol].height - 4));

        }

}

class editPanel extends Panel {
        editPanel()
        {
                super();
        }

        public Insets insets()
        {
                return new Insets(3,3,3,3);
        }
}

class dvorakWindow extends Frame {
        private int defWidth, defHeight;

        keyboardCanvas keyboard;

        dvorakWindow()
        {
                super("Your First Dvorak Lesson");

                setLayout(new BorderLayout());

                // get screen dimensions to size window
                Toolkit theToolkit = Toolkit.getDefaultToolkit();
                Dimension size = theToolkit.getScreenSize();
                defWidth = size.width/12 * 7;
                defHeight = size.height/12 * 5;

                MenuBar mBar = new MenuBar();
                setMenuBar(mBar);
                Menu fileMenu = new Menu("File");
                mBar.add(fileMenu);
                fileMenu.add(new MenuItem("Exit"));

                editPanel centerP = new editPanel();
                centerP.setLayout(new BorderLayout());
                centerP.setBackground(Color.gray);
                centerP.setForeground(Color.black);
                add("Center", centerP);

                // add a keyboardCanvas
                setLocation(size.width/12,size.height/20);
                setSize(defWidth, defHeight);

                centerP.add("North",
                        new Label("The Dvorak Keyboard",Label.CENTER));

                // add keyboard to Panel
                keyboard = new keyboardCanvas(this);
                keyboard.setSize(defWidth,defHeight);
                centerP.add("Center",keyboard);

                centerP.add("South",
                        new Label("Type a key to see its dvorak counterpart.",
                                  Label.CENTER));

                show();
        }

        public boolean handleEvent(Event evt)
        {
                switch (evt.id) {
                        case Event.ACTION_EVENT:
                                if ("Exit".equals(evt.arg))
                                {
                                        dispose();
                                        System.exit(0);
                                }
                                break;
                        case Event.WINDOW_DESTROY:
                                dispose();
                                System.exit(0);
                                break;
                        case Event.KEY_PRESS:
                                if (evt.key >= 33)
                                {
                                   keyboard.update = true;
                                   Point keyPos = keyboard.asciiPos[evt.key - 33];
                                   if (keyPos.x != -1)
                                   {
                                      keyboard.updateRow = keyPos.x;
                                      keyboard.updateCol = keyPos.y;
                                      keyboard.pressed[keyPos.x][keyPos.y] = true;
                                      keyboard.repaint();
                                   }
                                }
                                return true;
                        case Event.KEY_RELEASE:
                                if (evt.key >= 33)
                                {
                                   keyboard.update = true;
                                   Point keyPos = keyboard.asciiPos[evt.key - 33];
                                   if (keyPos.x != -1)
                                   {
                                      keyboard.updateRow = keyPos.x;
                                      keyboard.updateCol = keyPos.y;
                                      keyboard.pressed[keyPos.x][keyPos.y] = false;
                                      keyboard.repaint();
                                   }
                                }
                                return true;
                        case Event.GOT_FOCUS:
                                keyboard.update = false;
                                keyboard.paint(keyboard.getGraphics());
                                break;
                        default:
                                return false;
                }
                return false; // pass to parent if not handled
        }
}

class miniDvorak {
        public static void main(String args[])
        {
                new dvorakWindow();
        }
}
