// URLDisplayBeanInfo.java
package jwiley.chp11;

import java.beans.*;
import java.lang.reflect.Method;

/**
 * Bean info for the URLDisplay Bean
 */
public class URLDisplayBeanInfo extends SimpleBeanInfo {
    /**
     * Returns the Property list for the Bean
     */
    public PropertyDescriptor[] getPropertyDescriptors()
    {
        try
        {
            PropertyDescriptor background = new PropertyDescriptor("background", URLDisplay.class);
	        PropertyDescriptor foreground = new PropertyDescriptor("foreground", URLDisplay.class);
            PropertyDescriptor font = new PropertyDescriptor("font", URLDisplay.class);
            PropertyDescriptor display = new PropertyDescriptor("display", URLDisplay.class);
            PropertyDescriptor url = new PropertyDescriptor("URL", URLDisplay.class);

            PropertyDescriptor ret[] =  {background, foreground, display, font, url};
            return ret;
        }
        catch (IntrospectionException e)
          {
            throw new Error(e.toString());
          }
    }

    /**
     * Returns the index of the default property
     */
    public int getDefaultPropertyIndex()
    {
        return 4; // URL
    }

    /**
     * Returns the method list for the Bean
     */
    public MethodDescriptor[] getMethodDescriptors()
    {
        try
        {
            Method meth = URLDisplay.class.getMethod("reload", new Class[0]);
            MethodDescriptor reload = new MethodDescriptor(meth);
            MethodDescriptor ret[] = {reload};
            return ret;
        }
        catch (NoSuchMethodException x)
          {
            return null;
          }
    }

    /**
     * Returns the event list for the Bean
     */
    public EventSetDescriptor[] getEventSetDescriptors()
    {
        try
        {
            EventSetDescriptor loaded =
                new EventSetDescriptor(URLDisplay.class, "URLLoaded", URLLoadedListener.class, "URLLoaded");

            loaded.setDisplayName("URL Loaded");

            EventSetDescriptor ret[] = {loaded};
            return ret;
        }
        catch (IntrospectionException e)
        {
            throw new Error(e.toString());
        }
    }

    /**
     * Returns top-level information for the Bean
     */
    public BeanDescriptor getBeanDescriptor()
    {
        return new BeanDescriptor(URLDisplay.class, URLDisplayCustomizer.class);
    }

    /** load an icon for this bean. */
    public java.awt.Image getIcon(int iconKind)
    {
	    if (iconKind == BeanInfo.ICON_MONO_16x16 ||
	        iconKind == BeanInfo.ICON_COLOR_16x16 )
	    {
	        java.awt.Image img = loadImage("url16.gif");
	        return img;
	    }

	    if (iconKind == BeanInfo.ICON_MONO_32x32 ||
	        iconKind == BeanInfo.ICON_COLOR_32x32 )
	    {
	        java.awt.Image img = loadImage("url32.gif");
	        return img;
	    }

	    return null;
    }
}
