
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class AudioExampleApplet extends Applet implements ActionListener
{
	Button cmdWav = new Button ("Wav");
	Button cmdAu = new Button ("Au");
	Button cmdAiff = new Button ("Aiff");
	Button cmdRmf = new Button ("Rmf");
	Button cmdMidi = new Button ("Midi");
	Button cmdStop = new Button ("Stop");

	AudioClip audioClip;

	List lstStatus = new List();

	public AudioExampleApplet ()
	{
		Panel pnlButtons = new Panel();
		pnlButtons.setLayout(new FlowLayout());

		pnlButtons.add(cmdWav);
		pnlButtons.add(cmdAu);
		pnlButtons.add(cmdAiff);
		pnlButtons.add(cmdRmf);
		pnlButtons.add(cmdMidi);
		pnlButtons.add(cmdStop);

		cmdWav.addActionListener(this);
		cmdAu.addActionListener(this);
		cmdAiff.addActionListener(this);
		cmdRmf.addActionListener(this);
		cmdMidi.addActionListener(this);
		cmdStop.addActionListener(this);

		Panel pnlStatus = new Panel();
		pnlStatus.setLayout(new BorderLayout());

		pnlStatus.add("North", new Label("Status"));
		pnlStatus.add("Center", lstStatus);

		setLayout(new BorderLayout());
		add("Center", pnlStatus);
		add("South", pnlButtons);
	}

	public void actionPerformed (ActionEvent evt)
	{
		Object target = evt.getSource();

		if (target == cmdWav)
			playSound("managble.wav");

		else if (target == cmdAu)
			playSound("inconceivable.au");
		
		else if (target == cmdAiff)
			playSound("and_now.aiff");
		
		else if (target == cmdRmf)
			playSound("PersonalTwilight.rmf");
		
		else if (target == cmdMidi)
			playSound("nut1mrch.mid");

		else if (target == cmdStop)
		{
			if (audioClip != null)
			{
				debug("Play stopped");
				audioClip.stop();
			}
		}
	}

	private void playSound (String sSoundFile)
	{
		debug("Playing: " + sSoundFile.toString());
		audioClip = getAudioClip(getDocumentBase(), sSoundFile);
		audioClip.play();
	}

	private void debug (String sMessage)
	{
		lstStatus.add(sMessage);
		lstStatus.makeVisible(lstStatus.getItemCount() - 1);
	}
}