
package jwiley.chp12;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import jwiley.chp10.GraphPaperLayout;

public class SearchForm extends Applet implements ActionListener
{
    TextField   txtSearchText = new TextField();
    Checkbox    chkTitle = new Checkbox("Title");
    Checkbox    chkKeyword = new Checkbox("Keyword");
    Checkbox    chkText = new Checkbox("Text");

    Button      cmdSearch = new Button("Search");

    List        lstResults = new List();
    TextArea    txtDocumentView = new TextArea();

    Document    docs[] = null;

    public void init ()
    {
        // layout form
        setLayout(new GraphPaperLayout(8,8,2,2));

        add("1,1", new Label("Search:"));
        add("2,1,2,1", txtSearchText);
        add("4,1", cmdSearch);

        add("1,2", chkTitle);
        add("2,2", chkKeyword);
        add("3,2", chkText);

        add("1,4", new Label("Results:"));
        add("1,5,4,4", lstResults);

        add("6,1,2,1", new Label("Text Document:"));
        add("5,2,4,7", txtDocumentView);

        // set up event handlers
        cmdSearch.addActionListener(this);
        lstResults.addActionListener(this);
    }

    public void actionPerformed (ActionEvent evt)
    {
        SearchClient searchClient =
                new SearchClient(getCodeBase().getHost(), 8511);

        if (evt.getSource() == cmdSearch)
        {
            docs = searchClient.performSearch(txtSearchText.getText(),
                                              chkTitle.getState(),
                                              chkKeyword.getState(),
                                              chkText.getState());

            if (docs != null)
            {
                lstResults.removeAll();
                for (int iCount = 0; iCount < docs.length; iCount++)
                {
                    lstResults.add(docs[iCount].getTitle());
                }
            }
            else
                lstResults.removeAll();
        }
        else if (evt.getSource() == lstResults)
        {
            // find associated file name first
            if (docs != null)
            {
                String sListItem = evt.getActionCommand();
                for (int iCount = 0; iCount < docs.length; iCount++)
                {
                    if (docs[iCount].getTitle().equals(sListItem))
                    {
                        String sFileName = docs[iCount].getFileName();
                        String sDocumentText =
                            searchClient.getDocumentText(sFileName);

                        txtDocumentView.setText(sDocumentText);
                        break;
                    }
                }
            }
        }
    }
}