/*
* Client Implementation for remote 99 Bottles of beer
*/

package jwiley.chp13;

import Sing.*;				// Our package defining the proxy class
import org.omg.CosNaming.*;	// Support for naming service
import org.omg.CORBA.*;		// support for the CORBA objects themselves
/**
 * public class client
 * Contains the main method which will submit requests to the server
 */
public class client
{
    public static void main(String args[])
    {
		// Be good and always wrap code in try blocks!
		try
		{

			// create and initialize the ORB
			// If this was as applet instead we would replace args with the this pointer
			// so that the ORB could get arguments from it.
			ORB orb = ORB.init(args, null);
 
            // get the root naming context
            org.omg.CORBA.Object objRef = 
			orb.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);
 
            // resolve the Object Reference in Naming
            NameComponent nc = new NameComponent("bottles", "");
            NameComponent path[] = {nc};
			// use the narrow method to resolve our refence
			bottles theChorus = bottlesHelper.narrow(ncRef.resolve(path));

			/*
			 * We now have an object which we can talk to.
			 */
			for (int i=99; i > 0; i--)
			{
				theChorus.Chorus(i + " bottles of beer on the wall,");
				theChorus.Chorus(i + " bottles of beer.");
				theChorus.Chorus("If one of the bottles should happen to fall,");
				theChorus.Chorus(i-1 + " bottles of beer on the wall.");
			}

		} 
		catch (Exception e) 
		{
			System.out.println("ERROR : " + e) ;
			e.printStackTrace(System.out);
		}
    }
}
