// ActivateCounterSetup.java
package jwiley.chp14;

import java.rmi.*;
import java.rmi.activation.*;

public class ActivateCounterSetup
{
    public static void main(String args[])
    {
    	// Create and install the security manager
    	System.setSecurityManager(new RMISecurityManager());

    	try
        {
            ActivateCounterServer server = null;

            // Don't forget the trailing slash at the end of the URL
            // or your classes won't be found
            //
            String location = "file:/bk12updt/";

            // Create the rest of the parameters that will be passed to
            // the ActivationDesc constructor
            //
            MarshalledObject data = null;

            // The second argument to the ActivationDesc constructor will be used
            // to uniquely identify this class; it's location is relative to the
            // URL-formatted String, location.
            //
            ActivationDesc desc = new ActivationDesc
                ("jwiley.chp14.ActivateCounterServerImpl", location, data);

            server = (ActivateCounterServer) Activatable.register(desc);
            System.out.println("Got the stub for the ActivateCounterServerImpl");

            // Bind the stub to a name in the registry running on 1099
            //
            Naming.rebind("ActivateCounterServer", server);
            System.out.println("Exported ActivateCounterServer");

            System.exit(0);
    	} catch (Exception x)
           {
    	    x.printStackTrace();
    	    System.exit(1);
    	  }
        }
}