// File: CallbackCounterServerImpl.java
package jwiley.chp14;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

public class CallbackCounterServerImpl
        extends UnicastRemoteObject
        implements CallbackCounterServer
{
    private int iCount;

    public CallbackCounterServerImpl() throws java.rmi.RemoteException {
        iCount = 0;
    }

    public void registerForCount(CallbackCounterClient client)
                  throws RemoteException {
        client.setCount(++iCount);
    }

    public static void main(String args[])
    {
	// Create and install the security manager
        System.setSecurityManager(new RMISecurityManager());

	try {
            CallbackCounterServerImpl server = new
              CallbackCounterServerImpl();
            System.out.println("Server object created");
            Naming.rebind("CallbackCounterServer", server);
            System.out.println("Server object registered");
	} catch (Exception x)
	    {
            x.printStackTrace();
	    }
    }
}
