// File: SimpleCounterServerImpl.java
package jwiley.chp14;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

public class SimpleCounterServerImpl
	extends UnicastRemoteObject
        implements SimpleCounterServer
{
    private int iCount;

    public SimpleCounterServerImpl() throws java.rmi.RemoteException
    {
        iCount = 0;
    }

    public int getCount() throws RemoteException
    {
        return ++iCount;
    }

    public static void main(String args[])
    {
	// Create and install the security manager
	System.setSecurityManager(new RMISecurityManager());

	try
     {
            SimpleCounterServerImpl server = new SimpleCounterServerImpl();
            System.out.println("SimpleCounterServer created.");
            Naming.rebind("SimpleCounterServer", server);
            System.out.println("SimpleCounterServer registered.");
	} catch (Exception x)
       {
	    x.printStackTrace();
	  }
    }
}
