import java.io.*;
import java.security.*;


/**
 *  generateDigest outputs a digest of the file given using the algoritm supplied.
 *  @version 1.1
 *  @author A. Saganich
 *  @see java.Security.
 */

class generateDigest
{

	public static void main(String args[])
	{
		if ( args.length < 2)
		{
			System.out.println("Usage: generateDigest AlgorithmName fileToBeDigested\n");
			System.exit(0);
		}

		System.out.println("Attempting to generate message digest");
		System.out.println("\t          using " + args[0]);
		System.out.println("\t          on file " + args[1]);

		try
		{
			  CalculateDigest digest = new CalculateDigest(args[0],args[1]);
			  digest.Calculate();
			  byte[] result = digest.Result();
			  System.out.println("Resulting message digest = '" + result + "'");;
		}
		catch (NoSuchAlgorithmException e)
		{
			System.out.println("Algorithm "+ args[0] + " not found!");
		}
		catch (FileNotFoundException e)
		{
			System.out.println("File "+ args[1] + " not found!");			
		}
		catch (IOException e)
		{
			System.out.println("IO error on file "+ args[1]);			
		}
	}
}
