/**
  * testJar.java
  * Under normal circumstances this applet would raise a security exception.
  *
  * Run it with appletviewer after using the AnIdentity.bat file to create
  * the various components required for signed jar files.
  * 
  * @version Version 1.0
  * @author  Al Saganich
  *
  */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.applet.*;
import java.util.Enumeration;
import java.util.Properties;

public class testJar extends Applet 
{
	int pos = 9;
	final int totalOpen = 9;
	final int totalProtected = 3;
    String openKeys[] = new String[totalOpen];
    String protectedKeys[] = new String[totalProtected];


	public void init() 
	{
		openKeys[0] = new String("java.class.version");
		openKeys[1] = new String("java.vendor");
		openKeys[2] = new String("java.vendor.url");
		openKeys[3] = new String("os.name");
		openKeys[4] = new String("os.arch");
		openKeys[5] = new String("os.version");
		openKeys[6] = new String("file.separator");
		openKeys[7] = new String("path.separator");
		openKeys[8] = new String("line.separator");
		protectedKeys[0] = new String("user.name");
		protectedKeys[1] = new String("user.home");
		protectedKeys[2] = new String("user.dir");

	}

public void paint(Graphics g) 
{
	int y = 10;

	g.drawString("Attempting to access open system properties", 10, y+=10);
	System.out.println("Attempting to access open system properties");
	for (int i = 0; i < totalOpen; i++)
	{
		try 
		{
			String value = System.getProperty(openKeys[i]);
			g.drawString(openKeys[i] + ":= '" + value + "'", 10, y+=10);
			System.out.println(openKeys[i] + ":= '" + value + "'");
		}
		catch (SecurityException e) 
		{
			g.drawString("System.getProperty(" +openKeys[i] + "): caught security exception", 10, y+=10);
			System.out.println("System.getProperty(" +openKeys[i] + "): caught security exception");
		}
		catch (Exception e) 
		{
			g.drawString("System.getProperty(" +openKeys[i] + "): caught exception" + e , 10, y+=10);
			System.out.println("System.getProperty(" +openKeys[i] + "): caught exception" + e );
		}
	}
	g.drawString("Attempting to access protected system properties", 10, y+=10);
	System.out.println("Attempting to access protected system properties");
	for (int i = 0; i < totalProtected; i++)
	{
		try 
		{
			String value = System.getProperty(protectedKeys[i]);
			g.drawString(protectedKeys[i] + ":= '" + value + "'", 10, y+=10);
			System.out.println(protectedKeys[i] + ":= '" + value + "'");
		}
		catch (SecurityException e) 
		{
			g.drawString("System.getProperty(" +protectedKeys[i] + "): caught security exception", 10, y+=10);
			System.out.println("System.getProperty(" +protectedKeys[i] + "): caught security exception");
		}
		catch (Exception e) 
		{
			g.drawString("System.getProperty(" +protectedKeys[i] + "): caught exception" + e , 10, y+=10);
			System.out.println("System.getProperty(" +protectedKeys[i] + "): caught exception" + e );
		}
	}

  }
  	static public void main(String args[])
  	{
  		Frame frame = new Frame("testJar");
		frame.addWindowListener( new WindowAdapter()
  								{ 
  									public void windowClosing(WindowEvent w) 
  									{ 
  										System.exit(0); 
  									}	
  								}
  		);
  
  		frame.show();
        frame.setVisible(false);
  		frame.setSize(frame.getInsets().left + frame.getInsets().right  + 500,
  					 frame.getInsets().top  + frame.getInsets().bottom + 500);
  
  		//----------------------------------------------------------------------
  		testJar test = new testJar();
  
  		frame.add("Center", test);
  		test.init();
  		test.start();
        frame.show();
  	}

}

