
package jwiley.chp16;

import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Class to demonstrate the use of basic jdbc functionality
 *
 * @author  Eric Monk
 */

public class SimpleQuery
{
    public static void main (String args[])
    {
        try
        {
            // Load database driver
            Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
        } catch (ClassNotFoundException cnfe)
          {
            System.out.println(cnfe.toString());
            System.exit(0);
          }

        try
        {
            // Establish connection
            String sUrl = "jdbc:odbc:ExampleDb";
            Connection con = DriverManager.getConnection(sUrl);

            // Create and send statement
            String sQuery = "SELECT Author, Title, NumPages " +
                            "FROM BOOKS";

            Statement stmt = con.createStatement();
            ResultSet rslt = stmt.executeQuery(sQuery);

            // Process data
            while (rslt.next())
            {
                String sAuthor = rslt.getString("Author");
                String sTitle = rslt.getString("Title");
                int    iNumPages = rslt.getInt("NumPages");

                System.out.println(sTitle + " by " + sAuthor + " has " +
                                   iNumPages + " pages.");
            }

            // Cleanup
            rslt.close();
            stmt.close();

        } catch (SQLException sqle)
          {
            while (sqle != null)
            {
                System.out.println ("SQLState: " +
                                    sqle.getSQLState ());
                System.out.println ("Message:  " +
                                    sqle.getMessage ());
                System.out.println ("ErrorCode:   " +
                                    sqle.getErrorCode ());
                sqle = sqle.getNextException ();
                System.out.println ("");
            }
          }

    }
}