package jwiley.chp17;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.Enumeration;

/**
 * public class International
 * @author A. Saganich
 * @version 1.1
 *
 *  Sample applet using Locales and Resource bundles for internationalization.
 *  
 */
public class International extends Applet 
{
	Locale current;
	ResourceBundle myResources;
	private Locale supported[] =
	{
		Locale.US,
		Locale.UK,
		Locale.FRENCH,
		Locale.GERMAN
	};
	class ButtonHandler implements ActionListener 
	{
		public ButtonHandler() 
		{
		}
		public void actionPerformed(ActionEvent ae) 
		{
	        Button pushed = (Button)ae.getSource();
			String sCommand = ae.getActionCommand();
			if ("YesButton".equals(sCommand))
			{
				System.out.println("User hit 'Yes' button");
			}
			else if ("NoButton".equals(sCommand))
			{
				System.out.println("User hit 'No' button");				
			}
			else if ( "MaybeButton".equals (sCommand))
			{
				System.out.println("User hit 'Maybe' button");				
			}
		} // end ActionPerforned
	} // end NumberHandler implements ActionListener 


	public void init() 
	{
		current = supported[3]; //getLocale();
		int which = -1;
		for (int i = 0; i < supported.length;i++)
		{
			if ( current.equals(supported[i]))
			{
				which = i;
				break;
			}
		}
		// Default to english if not found.
		if ( which == -1)
			current = supported[0];
		myResources = ResourceBundle.getBundle("jwiley.chp17.MyResources",current);

		Panel topPanel = new Panel();
        topPanel.setLayout(new GridLayout(2,2));
		Label label = new Label(myResources.getString("language"),Label.LEFT);
		topPanel.add(label);
		
		label = new Label(current.getDisplayLanguage(),Label.RIGHT);
		topPanel.add(label);
		label = new Label(myResources.getString("curr"),Label.LEFT);
		topPanel.add(label);
		Label currency = new Label(myResources.getString("currValue"),Label.RIGHT);
		topPanel.add(currency);
        add("North",topPanel);

		Panel middlePanel = new Panel();
        middlePanel.setLayout(new GridLayout(1,2));
		label = new Label(myResources.getString("today"),Label.LEFT);
		middlePanel.add(label);
		Label date = new Label("31-July-1997",Label.RIGHT);
		middlePanel.add(date);
        add("Center",middlePanel);
		
	
        ButtonHandler bh = new ButtonHandler();
		Button b;
		Panel buttonPanel = new Panel();
        buttonPanel.setLayout(new GridLayout(1,3));
		buttonPanel.add(b = new Button(myResources.getString("yes")));
		b.setActionCommand("YesButton"); b.addActionListener(bh);
		buttonPanel.add(b = new Button(myResources.getString("no")));
		b.setActionCommand("NoButton"); b.addActionListener(bh);
		buttonPanel.add(b = new Button(myResources.getString("maybe")));
		b.setActionCommand("MaybeButton"); b.addActionListener(bh);
        add("South",buttonPanel);

	}

	/**
	 * Simple main method to test the applet.
	 */
	static public void main(String args[])
	{
	    class ShutdownAdapter extends WindowAdapter
	    {
	        public void windowClosing(WindowEvent e)
	        { System.exit(0); }
	    }

		Frame	myFrame	= new Frame("International");
		myFrame.addWindowListener(new ShutdownAdapter());
		International international = new International();
		myFrame.setSize(300,150);
		myFrame.add("Center",international);
		international.init();
		international.start();
		myFrame.show();
		
		
	}
}