package jwiley.chp17;
import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Frame;
import java.util.Locale;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;

/**
 * public class TestLocale
 * @author A. Saganich
 * @version 1.1
 *
 *  Sample applet to exercise the use of Locales.
 *
 *  @see java.util.Locale;
 */


public class TestLocale extends Applet 
{
	
	Locale current;
	private Locale supported[] =
	{
		Locale.US,
		Locale.UK,
		Locale.FRENCH,
		Locale.GERMAN
	};
	
	/** Determine what the current locale is */
	public void init() 
	{
		current = getLocale();
	}

	/** 
	* Display the currently supported locales 
	* And test if the current locale is supported.
	*/
	public void paint(Graphics g) 
	{
		int y = 10;
		int which = -1;
		g.drawString("Current locale is " + current.getDisplayName() , 10, y+=10);

		g.drawString("Supported locales are: ", 10, y+=10);
		for ( int i = 0; i < supported.length; i++)
		{
			g.drawString(supported[i].getDisplayName(), 20, y+=10);
			if ( current.equals(supported[i]) )
				which = i;
		}
		
		if (which != -1)
			g.drawString("Current locale is supported as " + which, 10, y+=10);
		else
			g.drawString("Locale " + current.getDisplayLanguage() + " is unsupported", 10, y+=10);
		
		
	}

	/**
	 * Simple main method to test the applet.
	 */
	static public void main(String args[])
	{
	    class ShutdownAdapter extends WindowAdapter
	    {
	        public void windowClosing(WindowEvent e)
	        { System.exit(0); }
	    }

		Frame	myFrame	= new Frame("TestLocale");
		myFrame.addWindowListener(new ShutdownAdapter());
		TestLocale TestLocale = new TestLocale();
		myFrame.setSize(300,150);
		myFrame.add("Center",TestLocale);
		TestLocale.init();
		TestLocale.start();
		myFrame.show();
		
		
	}
}