// BooksDetailPage.java
package jwiley.chp18;

import jwiley.chp18.html.*;

/**
 * This class represents the detail page for a book
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class BooksDetailPage extends HtmlPage
{
    public BooksDetailPage (String sServletAddress, BookRecord record)
    {
        super();

        HtmlHead head = null;
        if (record != null)
            head = new HtmlHead("Books Detail for Title: " +
                                                    record.getTitle());
        else
            head = new HtmlHead("New Book");

        StringBuffer sJavascript = new StringBuffer();
        sJavascript.append("<SCRIPT language=JavaScript>\n");
        sJavascript.append("<!-- hide from non-javascript browsers\n");
        sJavascript.append("function doSubmit (sAction)\n");
        sJavascript.append("{\n");
        sJavascript.append("document.forms.BookDetail.Command.value" +
                                                        "= sAction;\n");
        sJavascript.append("document.forms.BookDetail.submit();\n");
        sJavascript.append("}\n");
        sJavascript.append("// end hiding from old browsers -->\n");
        sJavascript.append("</SCRIPT>\n");

        head.addHtml(sJavascript.toString());

        // Body
        HtmlBody body = new HtmlBody();
        HtmlText title = null;
        if (record != null)
            title = new HtmlText("Books Detail", "H2");
        else
            title = new HtmlText("New Book", "H2");

        title.addFormatTag("CENTER");
        body.addComponent(title);

        // create anchors/links
        HtmlAnchor  aHome = new HtmlAnchor("",
                            new HtmlText("Home/Search"),
                            sServletAddress);

        body.addComponent(aHome);
        if (record != null)
        {
            String sNewBookLink = sServletAddress + "?" +
                                  BooksExampleHomePage.COMMAND_CONST + "=" +
                                  BooksExampleHomePage.NEW_COMMAND;
            HtmlAnchor  aNewBook = new HtmlAnchor("",
                                   new HtmlText("Add New Book"),
                                   sNewBookLink);
            body.addHtml("<BR>");
            body.addComponent(aNewBook);
        }

        body.addHtml("<HR SIZE=2>");

        // Create form here
        HtmlForm form = new HtmlForm("BookDetail", sServletAddress, "POST");

        // text fields/hidden fields
        HtmlHiddenInput bookidField = null;
        HtmlTextInput titleField = null;
        HtmlTextInput authorField = null;
        HtmlTextInput numpagesField = null;

        HtmlHiddenInput command = new HtmlHiddenInput("Command", "");

        if (record == null)
        {
            bookidField = new HtmlHiddenInput("bookid", "");
            titleField = new HtmlTextInput("title", "");
            authorField = new HtmlTextInput("author", "");
            numpagesField = new HtmlTextInput("numpages", "");
        }
        else
        {
            bookidField =
                    new HtmlHiddenInput("bookid", "" + record.getBookId());
            titleField = new HtmlTextInput("title", record.getTitle());
            authorField = new HtmlTextInput("author", record.getAuthor());
            numpagesField =
                    new HtmlTextInput("numpages", "" + record.getNumPages());
        }

        form.addComponent(command);
        form.addComponent(bookidField);

        HtmlTable table = new HtmlTable();
        HtmlTableRow rows[] = new HtmlTableRow[3];

        for (int iCount = 0; iCount < rows.length; iCount++)
        {
            rows[iCount] = new HtmlTableRow();
            table.addRow(rows[iCount]);
        }

        rows[0].addCell(new HtmlTableCell(new HtmlText("Title:")));
        rows[0].addCell(new HtmlTableCell(titleField));
        rows[1].addCell(new HtmlTableCell(new HtmlText("Author:")));
        rows[1].addCell(new HtmlTableCell(authorField));
        rows[2].addCell(new HtmlTableCell(new HtmlText("Num Pages:")));
        rows[2].addCell(new HtmlTableCell(numpagesField));

        form.addComponent(table);

        // add buttons
        HtmlInputButton save = new HtmlInputButton("Save", "Save");
        save.addParameter("onClick=doSubmit('" +
                            BooksExampleHomePage.SAVE_COMMAND + "')");
        HtmlInputButton delete = new HtmlInputButton("Delete", "Delete");
        delete.addParameter("onClick=doSubmit('" +
                            BooksExampleHomePage.DELETE_COMMAND + "')");

        if (record == null)
        {
            form.addComponent(save);
        }
        else
        {
            form.addComponent(save);
            form.addComponent(delete);
        }

        body.addComponent(form);

        setHead(head);
        setBody(body);
    }
}


