// BooksExampleHomePage
package jwiley.chp18;

import jwiley.chp18.html.*;

/**
 * This class represents the home page for the
 * Books Online example
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class BooksExampleHomePage extends HtmlPage
{
    public static String COMMAND_CONST = "Command";

    public static String NEW_COMMAND = "New";
    public static String SAVE_COMMAND = "Save";
    public static String DELETE_COMMAND = "Delete";
    public static String GET_COMMAND = "Get";
    public static String SEARCH_COMMAND = "Search";
    public static String LIST_ALL_COMMAND = "ListAll";

    String sServletAddress;

    public BooksExampleHomePage (String sServletAddress)
    {
        super();
        this.sServletAddress = sServletAddress;

        HtmlHead head = new HtmlHead("Books Example Home Page");

        // Body
        HtmlBody body = new HtmlBody();
        HtmlText title = new HtmlText("Books Online Home Page", "H2");
        title.addFormatTag("CENTER");
        body.addComponent(title);

        String sOverview = "This page will let you search for your favorite " +
                           "author or title. To search, please type in the name " +
                           "of an author or title and then click the Search button. " +
                           "You can also add a new book, or list all books currently " +
                           " in our database.";
        HtmlText overview = new HtmlText(sOverview, "P");
        body.addComponent(overview);
        body.addHtml("<HR SIZE=2>");

        BooksSearchForm searchForm = new BooksSearchForm(sServletAddress);
        body.addComponent(searchForm);

        setHead(head);
        setBody(body);
    }
}


