// BooksSearchForm.java
package jwiley.chp18;

import jwiley.chp18.html.*;

/**
 * This class represents an HTML form for searching
 * available books
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class BooksSearchForm extends HtmlForm
{
    public BooksSearchForm (String sServletAddress)
    {
        super("BooksSearchForm", sServletAddress, "GET");

        // create anchors/links
        HtmlAnchor  aHome = new HtmlAnchor("",
                            new HtmlText("Home"),
                            sServletAddress);

        String sListAllBooksLink = sServletAddress + "?" +
                                   BooksExampleHomePage.COMMAND_CONST + "=" +
                                   BooksExampleHomePage.LIST_ALL_COMMAND;
        HtmlAnchor  aListAllBooks = new HtmlAnchor("",
                                    new HtmlText("List All Books"),
                                    sListAllBooksLink);

        String sNewBookLink = sServletAddress + "?" +
                              BooksExampleHomePage.COMMAND_CONST + "=" +
                              BooksExampleHomePage.NEW_COMMAND;
        HtmlAnchor  aNewBook = new HtmlAnchor("",
                               new HtmlText("Add New Book"),
                               sNewBookLink);

        // add anchors to form
        addComponent(aHome);
        addHtml("<BR>");
        addComponent(aListAllBooks);
        addHtml("<BR>");
        addComponent(aNewBook);

        // create table
        HtmlTable table = new HtmlTable();
        HtmlTableRow rows[] = new HtmlTableRow[2];
        HtmlTableCell cells[][] = new HtmlTableCell[2][2];

        rows[0] = new HtmlTableRow();
        rows[1] = new HtmlTableRow();

        HtmlTextInput searchText = new HtmlTextInput("SearchText", "");
        HtmlSubmitButton submit = new HtmlSubmitButton("SearchButton", "Search");

        HtmlRadioButton searchAuthors =
                    new HtmlRadioButton("searchParams",
                                        "author",
                                        "Search by Author",
                                        true);
        HtmlRadioButton searchTitle =
                    new HtmlRadioButton("searchParams",
                                        "title",
                                        "Search by Title",
                                        false);

        HtmlHiddenInput command =
                new HtmlHiddenInput(BooksExampleHomePage.COMMAND_CONST,
                                    BooksExampleHomePage.SEARCH_COMMAND);

        cells[0][0] = new HtmlTableCell(searchText);
        cells[0][1] = new HtmlTableCell(submit);
        cells[1][0] = new HtmlTableCell(searchAuthors);
        cells[1][1] = new HtmlTableCell(searchTitle);

        rows[0].addCell(cells[0][0]);
        rows[0].addCell(cells[0][1]);
        rows[1].addCell(cells[1][0]);
        rows[1].addCell(cells[1][1]);

        table.addRow(rows[0]);
        table.addRow(rows[1]);

        // add table to form
        addHtml("<HR SIZE=2>");
        addHtml("<CENTER>");
        addComponent(table);
        addHtml("</CENTER>");
        addComponent(command);
    }
}