// MessagePage.java
package jwiley.chp18;

import jwiley.chp18.html.*;

/**
 * This class represents an Html Page used to display
 * a status or error message
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class MessagePage extends HtmlPage
{
    public MessagePage (String sServletAddress,
                        String sTitle, String sMessage)
    {
        HtmlHead head = new HtmlHead(sTitle);
        HtmlBody body = new HtmlBody();

        HtmlText title = new HtmlText(sTitle, "H2");
        body.addComponent(title);

        HtmlText message = new HtmlText(sMessage, "P");
        body.addComponent(message);

        // create anchors/links
        HtmlAnchor  aHome = new HtmlAnchor("",
                            new HtmlText("Home/Search"),
                            sServletAddress);

        body.addComponent(aHome);

        setHead(head);
        setBody(body);
    }
}