// HtmlInput
package jwiley.chp18.html;

import java.util.Vector;

/**
 * This class represents an html input field, this type of component
 * should only be added to an html form
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class HtmlInput implements HtmlComponent
{
    private String sType = "";
    private String sName = "";
    private String sValue = "";
    private Vector vParameters = new Vector();

    public HtmlInput (String sType, String sName, String sValue)
    {
        this.sType = sType;
        this.sName = sName;
        this.sValue = sValue;
    }

    public void addParameter(String sParameter)
    {
        vParameters.addElement(sParameter);
    }

    protected String getParameterString()
    {
        StringBuffer sbHtmlText = new StringBuffer();

        sbHtmlText.append("INPUT TYPE='" + sType + "'");
        if (!sName.equals(""))
            sbHtmlText.append(" NAME='" + sName + "'");

        if (!sValue.equals(""))
            sbHtmlText.append(" VALUE='" + sValue + "'");

        for (int iCount = 0; iCount < vParameters.size(); iCount++)
        {
            sbHtmlText.append(" " + (String)vParameters.elementAt(iCount));
        }

        return (sbHtmlText.toString());
    }

    public String getHtml()
    {
        StringBuffer sbHtmlText = new StringBuffer();

        sbHtmlText.append("<" + getParameterString() + ">\n");

        return (sbHtmlText.toString());
    }
}
