// HtmlContainer.hava
package jwiley.chp18.html;

/**
 * This class represents a single html page
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class HtmlPage implements HtmlComponent
{
    private HtmlHead head;
    private HtmlBody body;

    public HtmlPage()
    {
        head = new HtmlHead();
        body = new HtmlBody();
    }

    public HtmlPage(HtmlHead head, HtmlBody body)
    {
        this.head = head;
        this.body = body;
    }

    protected void setHead (HtmlHead head)
    {
        this.head = head;
    }

    protected void setBody (HtmlBody body)
    {
        this.body = body;
    }

    public String getHtml()
    {
        StringBuffer sbHtmlText = new StringBuffer();

        sbHtmlText.append("<HTML>\n");
        sbHtmlText.append(head.getHtml());
        sbHtmlText.append(body.getHtml());
        sbHtmlText.append("</HTML>\n");

        return (sbHtmlText.toString());
    }
}
