// HtmlRadioButton
package jwiley.chp18.html;

/**
 * This class represents an html radio button
 *
 * @author  Eric Monk
 * @version 1.0
 */
public class HtmlRadioButton extends HtmlInput
{
    private HtmlText label;
    private boolean  bChecked = false;

    public HtmlRadioButton (String sName, String sValue,
                            String sLabel, boolean bChecked)
    {
        super("radio", sName, sValue);
        this.label = new HtmlText(sLabel);
        this.bChecked = bChecked;
    }

    public HtmlRadioButton (String sName, String sValue,
                            HtmlText label, boolean bChecked)
    {
        super("radio", sName, sValue);
        this.label = label;
        this.bChecked = bChecked;
    }

    public String getHtml()
    {
        StringBuffer sbHtmlText = new StringBuffer();

        sbHtmlText.append("<" + getParameterString());
        if (bChecked)
            sbHtmlText.append(" CHECKED");

        sbHtmlText.append(">\n");
        sbHtmlText.append(label.getHtml());

        return (sbHtmlText.toString());
    }

}
