// CmdLineTest.java
package jwiley.chp2;

/**
 * Class to demonstrate the basics of Java command line
 * arguments.
 * @author Michael C. Daconta
 * @version 1.2
 */
class CmdLineTest
{
    /** Main() method to invoke from JVM. */
    public static void main(String args[])
    {
        /* 1) no need for argc because arrays have the
              length data member. */
        System.out.println("Number of command line args is " +
                           args.length);

        /* 2) command line args in Java are just
              an array of Strings. */
        for (int i=0; i < args.length; i++)
                System.out.println("arg #" + i + " is " +
                                   args[i]);

        /* 3) IMPORTANT: java arguments do NOT include
           the program name as in C and C++. */

        /* 4) flag arguments. */
        for (int i=0; i < args.length; i++)
        {
            if (args[i].startsWith("-"))
            {
                switch (args[i].charAt(1))
                {
                    case 'a':
                            System.out.println("a flag.");
                            break;
                    case 'b':
                            System.out.println("b flag.");
                            break;
                    case 'c':
                            System.out.println("c flag.");
                            break;
                    default:
                            /* normally error,
                            here do nothing to allow other
                            tests */ ;
                }
            }
        }

        /* 5) word arguments. */
        for (int i=0; i < args.length; i++)
        {
            if (args[i].equals("-verbose"))
                    System.out.println("Set the verbose flag.");
        }

        /* 6) arguments that require arguments. */
        for (int i=0; i < args.length; i++)
        {
            if (args[i].equals("-getNext"))
            {
                String nextArg = new String(args[++i]);
                System.out.println("next Arg is " + nextArg);
            }
        }
    }
}
