/** TestTableFrame.java */
package jwiley.chp21;

import javax.swing.*;
import javax.swing.table.*;

import java.awt.*;
import java.awt.event.*;

/**
 * Frame to test the JTable component.
 * @author Eric Monk
 */
public class TestTableFrame extends JFrame
{
    /** constructor. */
    public TestTableFrame (String sTitle)
    {
        super(sTitle);

        // create data model
        DatabaseTableModel dataModel = null;

        try {
            dataModel =
                  new DatabaseTableModel("jdbc:odbc:ExampleDB",
                                             "Books");
        } catch (Exception e)
          {
            System.out.println("Cannot get data model. Error: "
                                                    + e.toString());
            System.exit(0);
          }

    	// create table
        JTable table = new JTable(dataModel);

        // Put the table and header into a scrollPane
        JScrollPane scrollpane = new JScrollPane(table);
        getContentPane().add("Center", scrollpane);

        addWindowListener(new WindowAdapter()
                          {
                            public void windowClosing(WindowEvent we)
                            { System.exit(0); }
                          });

        setLocation(50,50);
        pack();
        show();
    }

    /** main method to invoke from the JVM. */
    public static void main (String args[])
    {
        new TestTableFrame("Test Table Frame");
    }
}
