// ValidationApplet.java
package jwiley.chp23;

import java.applet.Applet;
import java.awt.Graphics;

/**
 * Applet that implements logic to validate form input
 * A JavaScript page can use these routines instead
 * of implementing the logic itself
 */
public class ValidationApplet extends Applet
{
    /**
     * Checks the format of a string that is a person's name
     */
    public boolean validateName(String strName)
    {
        int len = strName.length();

        if (len  == 0)
            return true;

        for (int i = 0; i < len; i++)
        {
            char c = strName.charAt(i);

            if (!Character.isWhitespace(c) && Character.isDigit(c))
                return false;
        }

        return true;
    }

    /**
     * Checks the format of a string that represents a phone number
     */
    public boolean validatePhoneNumber(String strPhoneNum)
    {
        int len = strPhoneNum.length();

        if (len  == 0)
            return true;

        if (len  > 13)
            return false;

        for (int i = 0; i < len; i++)
        {
            char c = strPhoneNum.charAt(i);

            if (!Character.isDigit(c) && (c != '(' && c != ')' && c!= '-'))
                return false;
        }

        return true;
    }

    /**
     * Checks the format of a string that represents a person's age
     */
    public boolean validateAge(String strAge)
    {
        int len = strAge.length();
        int realAge;

        if (len  == 0)
            return true;

        try
        {
            realAge = Integer.parseInt(strAge);
        }
        catch (NumberFormatException x)
          {
            return false;
          }

	if (realAge < 0 || realAge > 120)
            return false;

        return true;
    }

    /**
     * Overridden from java.awt.Component.  We want to display
     * some text here so that users know when the applet has
     * loaded.
     */
    public void paint(Graphics g)
    {
        g.drawString("Validator ready", 10, 10);
    }
}