// ValidationApplet2.java
package jwiley.chp23;

import java.applet.Applet;
import java.awt.Graphics;
import netscape.javascript.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Applet that implements logic to validate form input
 * A JavaScript page can use these routines instead
 * of implementing the logic itself
 */
public class ValidationApplet2 extends Applet implements ActionListener
{
    Button bSubmit;
    Button bReset;

    public void init()
    {
        setLayout(new BorderLayout());
        bSubmit = new Button("Submit");
	  bSubmit.addActionListener(this);
        add("South", bSubmit);
        bReset = new Button("Reset");
	  bReset.addActionListener(this);
        add("North", bReset);	  
    };

    public void actionPerformed(ActionEvent evt)
    {
	  Button target = (Button) evt.getSource();
        if (target == bSubmit)
        {
            JSObject window = JSObject.getWindow(this);
            JSObject doc = (JSObject)window.getMember("document");
            JSObject form = (JSObject)doc.getMember("jsForm");
            validateForm(form);
        }

        if (target == bReset)
        {
            clearForm();
        }
    }

    /**
     * Checks the format of a string that is a person's name
     */
    public boolean validateName(JSObject form)
    {
        JSObject jsName = (JSObject)form.getMember("fullname");
        String strName = (String)jsName.getMember("value");
        int len = strName.length();

        if (len  == 0)
            return true;

        for (int i = 0; i < len; i++)
        {
            char c = strName.charAt(i);

            if (!Character.isWhitespace(c) && Character.isDigit(c))
            {
                JSObject.getWindow(this).eval("alert('Invalid name.  Please re-enter');");
                jsName.setMember("value", "");
                return false;
            }
        }

        return true;
    }

    /**
     * Checks the format of a string that represents a phone number
     */
    public boolean validatePhoneNumber(JSObject form)
    {
        JSObject jsPhone = (JSObject)form.getMember("phone");
        String strPhoneNum = (String)jsPhone.getMember("value");
        int len = strPhoneNum.length();

        if (len  == 0)
            return true;

        if (len  > 13)
        {
            JSObject.getWindow(this).eval("alert('Phone numbers must be of the form (###)###-####');");
            jsPhone.setMember("value", "");
            return false;
        }

        for (int i = 0; i < len; i++)
        {
            char c = strPhoneNum.charAt(i);

            if (!Character.isDigit(c) && (c != '(' && c != ')' && c!= '-'))
            {
                JSObject.getWindow(this).eval("alert('Phone numbers must be of the form (###)###-####');");
                jsPhone.setMember("value", "");
                return false;
            }
        }

        return true;
    }

    /**
     * Checks the format of a string that represents a person's age
     */
    public boolean validateAge(JSObject form)
    {
        JSObject jsAge = (JSObject)form.getMember("age");
        String strAge = (String)jsAge.getMember("value");
        int len = strAge.length();
        int realAge;

        if (len  == 0)
            return true;

        try
        {
            realAge = Integer.parseInt(strAge);
        }
        catch (NumberFormatException x)
          {
            JSObject.getWindow(this).eval("alert('Invalid age.  Please re-enter.');");
            jsAge.setMember("value", "");
            return false;
          }

        if (realAge < 0 || realAge > 120)
        {
            JSObject.getWindow(this).eval("alert('Invalid age.  Please re-enter.');");
            jsAge.setMember("value", "");
            return false;
        }

        return true;
    }

    public boolean validateSex(JSObject form)
    {
        Boolean bMale = (Boolean)((JSObject)form.getMember("msex")).getMember("status");
        Boolean bFemale = (Boolean)((JSObject)form.getMember("fsex")).getMember("status");

        if (bMale.booleanValue() && bFemale.booleanValue())
        {
            JSObject.getWindow(this).eval("alert('Cannot be both sexes.');");
            return false;
        }

        return true;
    }

    public boolean validateForm(JSObject form)
    {
        if (!validateName(form) ||
            !validatePhoneNumber(form) ||
            !validateAge(form) ||
            !validateSex(form))
        {
            return false;
        }

        // make sure we've filled it all in
        String strName = (String)((JSObject)form.getMember("fullname")).getMember("value");
        String strPhone = (String)((JSObject)form.getMember("phone")).getMember("value");
        String strAge = (String)((JSObject)form.getMember("age")).getMember("value");
        Boolean bMale = (Boolean)((JSObject)form.getMember("msex")).getMember("status");
        Boolean bFemale = (Boolean)((JSObject)form.getMember("fsex")).getMember("status");

	    if (strName.length() == 0 ||
            strPhone.length() == 0 ||
            strAge.length() == 0 ||
            (!bMale.booleanValue() && !bFemale.booleanValue()))
        {
            JSObject.getWindow(this).eval("alert('All fields must be filled in.  Form NOT submitted');");
            return false;
        }

        Object[] args = new Object[0];
        form.call("submit", args);

        return true;
    }

    public void clearForm()
    {
        JSObject window = JSObject.getWindow(this);
        JSObject doc = (JSObject)window.getMember("document");
        JSObject form = (JSObject)doc.getMember("jsForm");

        ((JSObject)form.getMember("fullname")).setMember("value", "");
        ((JSObject)form.getMember("phone")).setMember("value", "");
        ((JSObject)form.getMember("age")).setMember("value", "");
    }
}