//
// Assert.java
// This class is derived from many different discussions on Asserts and Java.
// 

public final class Assert
{
	public static boolean assertEnabled = false;
	public static void Assert(boolean condition, String description)
	{
		if ( true == assertEnabled && !condition ) failed(description);
	}
	public static void Assert(long condition, String description)
	{
		if ( true == assertEnabled && 0 == condition ) failed(description);
	}
	public static void Assert(double condition, String description)
	{
		if ( true == assertEnabled && 0.0 == condition ) failed(description);
	}
	public static void Assert(Object reference, String description)
	{
		if ( true == assertEnabled && null == reference ) failed(description);
	}
	private static void failed(String description)
	{
		System.err.println("Assertion failed:" + description);
		Throwable e = new Throwable();
		e.printStackTrace();
		System.exit(1);
	}
}
