// TstStatic.java
package jwiley.chp3;

/**
 * Simple class to demonstrate a static variable.
 */
class Entity
{
    /** Total number of Entity instantiated. */
    static long totalEntities = 0;
    /** Unique entity Id. */
    private long eId;

    /** constructor. */
    public Entity()
    {
        eId = totalEntities++;
        System.out.println("Total # of entities: " +
                                totalEntities);
    }
}

/**
 * Class to demonstrate a static method.
 */
class myMath
{
    /** method to calculate the fibonacci sum. */
    static int fibonacci(int n)
    {
        if (n == 0 || n == 1) return n;
        return (fibonacci(n - 1) + fibonacci(n - 2));
    }
}

/**
 * Wrapper class to test both uses of static.
 */
class TstStatic
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        System.out.println("Case 1: use of static variables.");
        Entity eArray[] = new Entity[5];
        for (int i=0; i < eArray.length; i++)
                eArray[i] = new Entity();

        System.out.println("Case 2: use of static methods.");
        System.out.println("fibonacci(14) is : "
                            + myMath.fibonacci(14));
    }
}