/*
* MyThread.Java
*/
package jwiley.chp4;

public class MyThread extends Thread
{
	//States the thread can be in
	static final int STATE_RUNNING = 0;
	static final int STATE_STOP    = 1;
	static final int STATE_SUSPEND = 2;

	private int currentState = STATE_RUNNING;


	//
	// The public method changeState allows 
	// another process to poke at the thread
	// and tell it to do something when it next gets a chance.
	public final synchronized void changeState(int newState)
	{
		currentState = newState;
		if (STATE_RUNNING == currentState)
			notify();  // Must have been previously suspended
	}

	private synchronized boolean currentState()
	{
		// If we where asked to suspend just hang out
		// until we are asked to either run or stop.
		while ( STATE_SUSPEND == currentState)
		{
			try{ wait(); } catch (Exception e) {};
		}
		if ( STATE_STOP == currentState )
			return false;
		else
			return true;
	}

	public void run()
	{
		do
		{
			if (currentState() == false) return; // Done
			
			//Perform some work
			
		} while (true);
		
	}

	
}