/** TestTraverse.java -  tests the Traverse interface. */
import List.ListHead;
import List.IllegalListOpException;

/** Class to demonstrate the linked list implementation of
    the Traverse interface. */
public class TestTraverse
{
    /** main() method to invoke from JVM. */
	public static void main(String args[])
	{
		ListHead myList = new ListHead(true);

		myList.addElement(new Integer(100));
		myList.addElement(new Integer(200));
		myList.addElement(new Integer(300));
		myList.addElement(new Integer(400));
		myList.addElement(new Integer(500));
		myList.addElement(new Integer(600));

		System.out.println("List size: " + myList.size());

		System.out.println("Forward...");
		while (!myList.atEnd())
				System.out.println(((Integer)myList.next()));

		System.out.println("Backward...");
		while (!myList.atStart())
		{
			try
			{
				System.out.println(((Integer)myList.prev()));
			}
			catch (IllegalListOpException iloe)
			{
				System.out.println(iloe.toString());
				System.exit(1);
			}
		}

			System.out.println("Go forward three nodes.");
			for (int i=0; i < 3; i++)
			{
				if (!myList.atEnd())
					System.out.println((Integer)myList.next());
			}

			System.out.println("Go Back three nodes.");
			for (int i=0; i < 3; i++)
			{
				if (!myList.atStart())
				{
					try
					{
						System.out.println(((Integer)myList.prev()));
					}
					catch (IllegalListOpException iloe)
					{
						System.out.println(iloe.toString());
						System.exit(1);
					}
				}
			}

			System.out.println("Jump to Start...");
			System.out.println((Integer)myList.start());

			System.out.println("Jump to End...");
			System.out.println((Integer)myList.end());
	}
}
