// accessData.c
// This simple example shows how to use the JNI functions 
//
#include <stdio.h>
#include <jni.h>
#include "AccessData.h"

JNIEXPORT void JNICALL 
Java_AccessData_cAccessData(JNIEnv *pJNIEnv, jobject jObject)
{
  jclass cls = (*pJNIEnv)->GetObjectClass(pJNIEnv, jObject);
  jfieldID fID;
  jstring jString;
  const char *pCString;
  jint si;

  printf("In C:\n");

  fID = (*pJNIEnv)->GetStaticFieldID(pJNIEnv, cls, "aStaticInteger", "I");
  if (fID == 0)
    return;
  si = (*pJNIEnv)->GetStaticIntField(pJNIEnv, cls, fID);
  printf("  anObject.si = %d (should be 200 after 'C' access)\n", si);
  (*pJNIEnv)->SetStaticIntField(pJNIEnv, cls, fID, 200);
  
  fID = (*pJNIEnv)->GetFieldID(pJNIEnv, cls, "aString", "Ljava/lang/String;");
  if (fID == 0)
    return;
  jString = (*pJNIEnv)->GetObjectField(pJNIEnv, jObject, fID);
  pCString = (*pJNIEnv)->GetStringUTFChars(pJNIEnv, jString, 0);
  printf("  anObject.s = \"%s\"\n", pCString);
  (*pJNIEnv)->ReleaseStringUTFChars(pJNIEnv, jString, pCString);

  jString = (*pJNIEnv)->NewStringUTF(pJNIEnv, "123");
  (*pJNIEnv)->SetObjectField(pJNIEnv, jObject, fID, jString);
}