// TestStrings.java
package jwiley.chp6;

import java.io.BufferedReader;import java.io.InputStreamReader;
import java.io.IOException;

/** class to demonstrate String and StringBuffer class. */
public class TestStrings
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        if (args.length < 1)
        {
                System.out.println("USAGE: java tstStrings someString");
                System.exit(1);
        }

        String clString = new String(args[0]);
        System.out.println("Command line string is : " + clString);

        // count characters and digits
        int charCount = 0;
        int digitCount = 0;
        for (int i=0; i < clString.length(); i++)
            if (!Character.isDigit(clString.charAt(i)) &&
                !Character.isWhitespace(clString.charAt(i)))
                    charCount++;
            else if (Character.isDigit(clString.charAt(i)))
                    digitCount++;

        System.out.println("# of Chars : " + charCount +
                          " # of Digits: " + digitCount);

        // construct a sentence
        BufferedReader br = new BufferedReader(
                            new InputStreamReader(System.in));
        System.out.println("Hit <ret> after each word, to exit type" +
                           " a '.'");
        String word=null;
        StringBuffer sentence = new StringBuffer();
        do
        {
          try
          {
              word = br.readLine();
          } catch (IOException ioe)
            {
                System.out.println("IOException.");
                break;
            }
            if (!word.equals("."))
              sentence.append(word + " ");
            else
              sentence.setCharAt(sentence.length() - 1, '.');
        } while (!word.equals("."));

        System.out.println("Sentence : " + sentence);
    }
}
