// TestThreads.java
package jwiley.chp6;

import java.util.Random;

/** simple class to demonstrate a Thread. */
class DummyThread extends Thread
{
    /** Count of all threads created. */
    static int dummyThreadCount = 0;
    /** number of seconds thread should sleep. */
    int Seconds;
    /** unique id for this thread. */
    int id;

    /** constructor. */
    DummyThread()
    {
        id = ++dummyThreadCount;
        Random dice = new Random(System.currentTimeMillis() +
                                 dummyThreadCount);
        Seconds = Math.abs(dice.nextInt() % 100);
    }

    /** runnable method. */
    public void run()
    {
        System.out.println("Dummy Thread # " + id +
                           " is sleeping for " + Seconds +
                           " seconds.");
        try { sleep(Seconds * 1000); } catch (Exception e) { }
        System.out.println("Thread # " + id + " is awake.");
    }
}

/** Class to demonstrate the Thread class. */
public class TestThreads
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        Random generator = new Random();
        int numThreads = Math.abs(generator.nextInt() % 10);

        System.out.println("Number of Threads to start: " +
                           numThreads);
        for (int i=0; i < numThreads; i++)
        {
            DummyThread d = new DummyThread();
            d.start();
        }

        Thread currentThread = Thread.currentThread();
        ThreadGroup theGroup = currentThread.getThreadGroup();
        theGroup.list();  // list all threads in the group
    }
}
