// SideView.java
package jwiley.chp7;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Canvas;
import java.util.Observable;
import java.util.Observer;

/**
 * This class displays a side view of the given model
 *
 * @author  Eric Monk
 * @version 1.0
 */

public class SideView implements Observer
{
    public static final int LEFT_RIGHT_VIEW = 1;
    public static final int TOP_BOTTOM_VIEW = 2;

    SimpleSlider    ss;
    int             iView;

    public SideView (int iView, PositionModel pm)
    {
        this.iView = iView;
        if (iView != LEFT_RIGHT_VIEW)
            iView = TOP_BOTTOM_VIEW;

        ss = new SimpleSlider(calculatePercent(pm), 6);
    }

    public Canvas getCanvas()
    {
        return (ss);
    }

    public void update(Observable o, Object arg)
    {
        PositionModel pm = (PositionModel) arg;
        ss.setMarker(calculatePercent(pm));
    }

    int calculatePercent(PositionModel pm)
    {
        Rectangle r = pm.getFieldSize();
        Point p = pm.getPosition();

        int iPercent = 0;
        if (iView == LEFT_RIGHT_VIEW)
            iPercent = (int) (((float)p.y / (float)r.height) * 100);
        else
            iPercent = (int) (((float)p.x / (float)r.width) * 100);

        return (iPercent);

    }
}
