package jwiley.chp7;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import jwiley.chp10.Grid;

public class SortExample extends Frame implements ActionListener
{
    java.awt.List lstPeople = new java.awt.List();
    java.awt.List lstSortBy = new java.awt.List();
    Button  cmdSort = new Button("Sort");
    Button  cmdClose = new Button("Close");

    ArrayList al = new ArrayList();

    public SortExample (String sTitle)
    {
        super (sTitle);

        setLayout(new Grid(1,12));

        Panel pnlButtons = new Panel();
        pnlButtons.add(cmdSort);
        pnlButtons.add(cmdClose);

        add("1,1", new Label("People (Age, # Family Members, Name)"));
        add("1,2,1,5", lstPeople);
        add("1,7", new Label("Sort By"));
        add("1,8,1,3", lstSortBy);
        add("1,11,1,2", pnlButtons);

        lstSortBy.addActionListener(this);
        cmdSort.addActionListener(this);
        cmdClose.addActionListener(this);

        al.add(new Person("Cameron", 2, 4));
        al.add(new Person("Kyle", 5, 6));
        al.add(new Person("Nicole", 2, 3));
        al.add(new Person("Katie", 3, 5));
        al.add(new Person("Matthew", 1, 4));
        al.add(new Person("Mark", 29, 1));

        lstSortBy.add("(Default)");
        lstSortBy.add("Name");
        lstSortBy.add("Age");
        lstSortBy.add("Family Size");

        sortList("(Default)");

        setSize(300,400);
        show();
    }

    public void actionPerformed (ActionEvent evt)
    {
        Object target = evt.getSource();

        if (target == lstSortBy || target == cmdSort)
            sortList(lstSortBy.getSelectedItem());
        else if (target == cmdClose)
        {
            dispose();
            System.exit(0);
        }
    }

    private void sortList (String sSortCriteria)
    {
        if (sSortCriteria == null || sSortCriteria.equals(""))
            return;

        Comparator c = null;
        if (sSortCriteria.equals("Name"))
            c = new NameComparator();
        else if (sSortCriteria.equals("Age"))
            c = new AgeComparator();
        else if (sSortCriteria.equals("Family Size"))
            c = new FamilySizeComparator();

        Object sortObj[] = al.toArray();
        if (c == null)
            Arrays.sort(sortObj);
        else
            Arrays.sort(sortObj, c);

        al.clear();
        for (int iCount = 0; iCount < sortObj.length; iCount++)
            al.add(sortObj[iCount]);

        displayPeople(al);
    }

    private void displayPeople(ArrayList al)
    {
        lstPeople.removeAll();

        Iterator it = al.iterator();

        while (it.hasNext())
        {
            Person p = (Person) it.next();
            lstPeople.add(p.iAge + ", " + p.iNumFamilyMembers
                                                + ", " + p.sName);
        }
    }

    public static void main (String args[])
    {
        new SortExample("Sort Example");
    }
}

class Person implements Comparable
{
    String sName = "";
    int iAge;
    int iNumFamilyMembers;

    public Person ()    {   }

    public Person (String sName, int iAge, int iNumFamilyMembers)
    {
        this.sName = sName;
        this.iAge = iAge;
        this.iNumFamilyMembers = iNumFamilyMembers;
    }

    private Comparator defaultComparator =
                            new NameComparator();

    public int compareTo (Object o)
    {
        return (defaultComparator.compare(this, o));
    }
}

class AgeComparator implements Comparator
{
    public int compare (Object person1, Object person2)
    {
        int iAge1 = ((Person)person1).iAge;
        int iAge2 = ((Person)person2).iAge;
        return (iAge1 - iAge2);
    }
}

class NameComparator implements Comparator
{
    public int compare (Object person1, Object person2)
    {
        String sName1 = ((Person)person1).sName;
        String sName2 = ((Person)person2).sName;
        return (sName1.compareTo(sName2));
    }
}

class FamilySizeComparator implements Comparator
{
    public int compare (Object person1, Object person2)
    {
        int iNumFamilyMembers1 = ((Person)person1).iNumFamilyMembers;
        int iNumFamilyMembers2 = ((Person)person2).iNumFamilyMembers;
        return (iNumFamilyMembers1 - iNumFamilyMembers2);
    }
}