
package jwiley.chp8;

import java.io.Serializable;
import java.util.Date;

/**
 * Class that stores a Date and a Time
 *
 * @author Eric Monk
 * @version 1.0
 */
public class ReminderData implements Serializable
{
    Date    dtReminderDate;
    String  sReminderText;

    int     iDurationHours;
    String  sReasonWhy;

    static final long serialVersionUID = -6643007435454390103L;

    /** Constructor needed to maintain backward compatibility */
    public ReminderData (Date dtReminderDate, String sReminderText)
    {
        this (dtReminderDate, sReminderText, 0, "");
    }

    /** A newer constructor */
    public ReminderData (Date dtReminderDate, String sReminderText,
                            int iDurationHours, String sReasonWhy)
    {
        this.dtReminderDate = dtReminderDate;
        this.sReminderText = sReminderText;
        this.iDurationHours = iDurationHours;
        this.sReasonWhy = sReasonWhy;
    }

    /** method to set the reminder date */
    public void setReminderDate (Date dtReminderDate)
    {
        this.dtReminderDate = dtReminderDate;
    }

    /** method to get the reminder date */
    public Date getReminderDate ()
    {
        return (dtReminderDate);
    }

    /** method to set the reminder text */
    public void setReminderText (String sReminderText)
    {
        this.sReminderText = sReminderText;
    }

    /** method to get the reminder text */
    public String getReminderText ()
    {
        return (sReminderText);
    }

    /** method to set the duration */
    public void setDuration (int iDurationHours)
    {
        this.iDurationHours = iDurationHours;
    }

    /** method to get the duration */
    public int getDuration ()
    {
        return (iDurationHours);
    }

    /** method to set the reason */
    public void setReasonWhy (String sReasonWhy)
    {
        this.sReasonWhy = sReasonWhy;
    }

    /** method to get the reason */
    public String getReasonWhy ()
    {
        return (sReasonWhy);
    }
}