
package jwiley.chp9;

import java.io.DataInputStream;
import java.io.IOException;

public class ClientProxy extends Thread
{
    IMessageHandler messageHandler;
    DataInputStream messageListener;
    boolean         bStopThread = false;

    public ClientProxy (IMessageHandler messageHandler, DataInputStream dis)
    {
        this.messageHandler = messageHandler;
        this.messageListener = dis;

        this.start();
    }

    public void stopListen ()
    {
        bStopThread = true;
    }

    public void run ()
    {
        while (!bStopThread)
        {
            try
            {
                String sSpeakerName = messageListener.readUTF();
                String sMessage = messageListener.readUTF();

                messageHandler.handleMessage(sSpeakerName, sMessage);
            } catch (IOException ioe)
              {
                System.out.println("Error receiving message. " +
                                        ioe.toString());
                break;
              }
        }
    }
}

