
package jwiley.chp9;

import java.io.IOException;
import java.util.StringTokenizer;
import java.util.NoSuchElementException;

import java.net.DatagramPacket;
import java.net.DatagramSocket;

public class DClientProxy extends Thread
{
    DatagramSocket  proxy;
    IMessageHandler messageHandler;
    int             iPort;
    boolean         bStopThread = false;

    static int      MSG_SIZE = 256;

    public DClientProxy (IMessageHandler messageHandler, int iPort) throws IOException
    {
        this.messageHandler = messageHandler;
        this.iPort = iPort;

        proxy = new DatagramSocket(iPort);

        this.start();
    }

    public void stopListen ()
    {
        proxy.close();
        bStopThread = true;
    }

    public void sendPacket (DatagramPacket p)
    {
        try
        {
            proxy.send(p);
        } catch (IOException ioe)
          {
            System.out.println("Error sending message. Error: " + ioe.toString());
          }
    }

    public void run ()
    {
        while (!bStopThread)
        {
            byte b[] = new byte[MSG_SIZE];
            DatagramPacket p = new DatagramPacket(b, b.length);

            try
            {
                proxy.receive(p);

                String sPacketData = new String(p.getData(), 0, p.getLength());
                StringTokenizer st = new StringTokenizer(sPacketData, ":");

                String sMessageType = st.nextToken();
                String sMessageData = st.nextToken();

                messageHandler.handleMessage(sMessageType, sMessageData);
            }
            catch (IOException ioe)
            {
                System.out.println("Error receiving packet. Error: "
                                        + ioe.toString());
            }
            catch (NoSuchElementException nsee)
            {
                System.out.println("Invalid message type from "
                                        + p.getAddress().toString());
            }

        }
    }
}

