// SocketReader.java
package jwiley.chp9;

import java.net.ServerSocket;
import java.net.Socket;
import java.io.InputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

/** Class to demonstrate reading from a Socket. */
public class SocketReader
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
         if (args.length < 1)
         {
            System.out.println("USAGE: java SocketReader port");
            System.exit(1);
         }

         String portStr = new String(args[0]);

         try
         {
            int port = Integer.parseInt(portStr);

            // create the server socket
            ServerSocket readServer = new ServerSocket(port);
            System.out.println("Server Socket created to " + port);
            System.out.println("Awaiting a connection...");

            // wait for a connection
            Socket connection = readServer.accept();
            System.out.println("Connection accepted.");

            // set up the streams
            InputStream inStream = connection.getInputStream();
            BufferedReader br = new BufferedReader(new InputStreamReader(inStream));

            // while input does not equal 'exit' output to socket
            boolean done = false;
            while (!done)
            {
                String line = br.readLine();
                if (!line.startsWith("~READER_STOP~"))
                {
                        System.out.println(line);
                }
                else
                        done = true;
            }

            // close the server
            readServer.close();
         } catch (Exception e)
           {
            e.printStackTrace();
            System.exit(1);
           }
    }
}
