// SocketWriter.java
package jwiley.chp9;

import java.net.Socket;
import java.io.OutputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.PrintWriter;

/** Class to demonstrate writing to a Socket. */
public class SocketWriter
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
         if (args.length < 2)
         {
            System.out.println("USAGE: java SocketWriter hostname port");
            System.exit(1);
         }

         String host = new String(args[0]);
         String portStr = new String(args[1]);

         try
         {
            int port = Integer.parseInt(portStr);

            // create the socket
            Socket outSock = new Socket(host,port);
            System.out.println("Socket created to " + host);

            // set up the streams
            OutputStream outStream = outSock.getOutputStream();
            PrintWriter pw = new PrintWriter(outStream, true);
            BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

            // while input does not equal 'exit' output to socket
            boolean done = false;
            System.out.println("Type sentences to send. Type 'exit' to quit.");
            while (!done)
            {
                String line = br.readLine();
                if (!line.startsWith("exit"))
                {
                    pw.println(line);
                }
                else
                {
                    // stop reader
                    pw.println("~READER_STOP~");
                    done = true;
                }
            }

            // close the socket
            outSock.close();
         } catch (Exception e)
           {
            e.printStackTrace();
            System.exit(1);
           }
    }
}
