// TestUrl.java
package jwiley.chp9;

import java.net.URL;
import java.net.MalformedURLException;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

/** Class to demonstrate the use of the URL class. */
public class TestUrl
{
    /** main() method to invoke from JVM. */
    public static void main(String args[])
    {
        if (args.length < 2)
        {
            System.out.println(
                    "USAGE: java TestUrl URL_string output_file_name");
            System.exit(1);
        }

        String urlString = new String(args[0]);
        String fileName = new String(args[1]);

        URL theURL = null;
        try
        {
            theURL = new URL(urlString);
        } catch (MalformedURLException mue)
          {
            System.out.println(mue.toString());
            System.exit(1);
          }

        try
        {
          byte buf[] = new byte[1000];
          InputStream input = theURL.openStream();
          FileOutputStream fout = new FileOutputStream(fileName);
          int ch;
          int count = 0;
          while (true)
          {
               int n = input.read(buf, 0, 1000);
               if (n == -1) break;
               fout.write(buf, 0, n);
               count += n;
               System.out.print(".");
               System.out.flush();
          }

          fout.close();
          input.close();
        } catch (IOException ioe)
          {
            ioe.printStackTrace();
            System.exit(1);
          }
    }
}
